/* 	MacOsXHandler.java
 *	Copyright (c) 2007, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Feb 27, 2007
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.attest.macosx;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.brains2b.attest.OsStub;

import com.apple.eawt.Application;
import com.apple.eawt.ApplicationAdapter;
import com.apple.eawt.ApplicationEvent;

public class MacOsXHandler extends ApplicationAdapter implements OsStub {

	private String m_filename;
	private List m_listeners = new ArrayList();
	
	public MacOsXHandler() {
		super();
		init();
	}

	
	private void init() {
		Application.getApplication().addApplicationListener(this);
	}
	
	public void handleOpenFile(ApplicationEvent arg0) {
		m_filename=arg0.getFilename();
		for (Iterator it = m_listeners.iterator();it.hasNext();) {
			((ActionListener) it.next()).actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,"Open"));
		}
		arg0.setHandled(true);
		super.handleOpenFile(arg0);
	}


	public String getFilename() {
		return m_filename;
	}


	public void addActionListener(ActionListener listener) {
		m_listeners.add(listener);
		
	}


	public void removeActionListener(ActionListener listener) {
		m_listeners.remove(listener);
		
	}
}
